=== added file 'plugin/innobase/tests/r/innodb_bug49164.result'
--- plugin/innobase/tests/r/innodb_bug49164.result	1970-01-01 00:00:00 +0000
+++ plugin/innobase/tests/r/innodb_bug49164.result	2010-11-11 10:32:51 +0000
@@ -0,0 +1,42 @@
+SET tx_isolation = 'READ-COMMITTED';
+CREATE TABLE bug49164 (a INT, b BIGINT, c TINYINT, PRIMARY KEY (a, b))
+ENGINE=InnoDB;
+insert into bug49164 values (1,1,1), (2,2,2), (3,3,3);
+begin;
+update bug49164 set c=7;
+select * from bug49164;
+a	b	c
+1	1	7
+2	2	7
+3	3	7
+rollback;
+select * from bug49164;
+a	b	c
+1	1	1
+2	2	2
+3	3	3
+begin;
+update bug49164 set c=7;
+SET tx_isolation = 'READ-COMMITTED';
+begin;
+select * from bug49164;
+a	b	c
+1	1	1
+2	2	2
+3	3	3
+commit;
+begin;
+update bug49164 set c=6 where a=1 and b=1;
+rollback;
+select * from bug49164;
+a	b	c
+1	1	1
+2	2	2
+3	3	3
+commit;
+select * from bug49164;
+a	b	c
+1	1	6
+2	2	2
+3	3	3
+drop table bug49164;

=== added file 'plugin/innobase/tests/t/innodb_bug49164.test'
--- plugin/innobase/tests/t/innodb_bug49164.test	1970-01-01 00:00:00 +0000
+++ plugin/innobase/tests/t/innodb_bug49164.test	2010-11-11 10:32:51 +0000
@@ -0,0 +1,47 @@
+-- source include/have_innodb.inc
+
+# Bug #49164 READ-COMMITTED reports "matched: 0" on compound PK
+# a duplicate of
+# Bug #52663 Lost update incrementing column value under READ COMMITTED
+
+connect (con1,localhost,root,,);
+connect (con2,localhost,root,,);
+
+connection con1;
+SET tx_isolation = 'READ-COMMITTED';
+
+CREATE TABLE bug49164 (a INT, b BIGINT, c TINYINT, PRIMARY KEY (a, b))
+ENGINE=InnoDB;
+
+insert into bug49164 values (1,1,1), (2,2,2), (3,3,3);
+
+begin;
+update bug49164 set c=7;
+select * from bug49164;
+rollback;
+select * from bug49164;
+begin;
+update bug49164 set c=7;
+
+connection con2;
+
+SET tx_isolation = 'READ-COMMITTED'; 
+begin;
+select * from bug49164;
+commit;
+begin;
+--send
+update bug49164 set c=6 where a=1 and b=1;
+
+connection con1;
+rollback;
+select * from bug49164;
+connection con2;
+reap;
+commit;
+connection con1;
+select * from bug49164;
+connection default;
+disconnect con1;
+disconnect con2;
+drop table bug49164;

